=begin
TIG (c) 2012
All Rights Reserved.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
WARRANTIES,INCLUDING,WITHOUT LIMITATION,THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
###
TIG-originatecomponentsaxes.rb
###
Usage:
Preselect some Component-Instances [other things are ignored].
###
Ruby Console: TIG::originatecomponentsaxes()
Tool Menu: TIG::originate components axes
###
The component definitions are made unique if needed, then adjusted so that 
their axes [insertion-point] is at the model-origin and the transformations 
of their instances are inverted so the instances do not move...
###
Donations:
By PayPal.com to info @ revitrev.org
###
Version:
1.0 20120228 First Issue.
###
=end
require 'sketchup'
###
module TIG
unless file_loaded?(File.basename(__FILE__))
  UI.menu('Tools').add_item('TIG::originate components axes'){self::originatecomponentsaxes()}
end
file_loaded(File.basename(__FILE__))
###
def self.originatecomponentsaxes()
  model=Sketchup.active_model
  is=model.selection.to_a.find_all{|i|
    i.class==Sketchup::ComponentInstance
  }
  model.start_operation('originatecomponentsaxes')
  is.each{|i|
    i.make_unique if i.definition.instances[1]
    d=i.definition
    t=i.transformation
    es=d.entities
    es.transform_entities(t, es.to_a)
    i.transform!(t.inverse)
  }
  model.commit_operation
end
end
